/*
 * Copyright (c) 1992-2002 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/4.2/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.2 $";
#endif

#include "defs.h"
#include "dmi.h"

static char		       *s = "Supports";
static DevDesc_t	      **lp;

/*
 * Values for DmiStructSysInfo_t.WakeUp
 */
static char *WakeUpList[] = {
    "",
    "",
    "",
    "APM Timer",
    "Modem Ring",
    "LAN Remote",
    "Power Switch",
    "PCI PME#",
    "AC Power Restored",
    NULL
};

/*
 * Decode DMI System Information (DMI_STRUCT_SYSINFO)
 */
extern DevInfo_t *DmiDecodeSysInfo(Hdr, Data, Dmi, Query)
     DmiHeader_t	       *Hdr;
     void		       *Data;
     Dmi_t		       *Dmi;
     DmiQuery_t		       *Query;
{
    DevInfo_t		       *DevInfo;
    DmiStructSysInfo_t	       *Sys;
    char		       *Mfg = NULL;
    char		       *Model = NULL;
    char		       *Version = NULL;
    char		       *Serial = NULL;
    char		       *cp;
    static char			Buff[128];
    static int			Unit;

    Sys = (DmiStructSysInfo_t *) Data;

    if ((cp = DmiString(Hdr, Sys->Mfg)) && !DmiIsGeneric(cp))
	Mfg = cp;
    if ((cp = DmiString(Hdr, Sys->Product)) && !DmiIsGeneric(cp))
	Model = cp;
    if ((cp = DmiString(Hdr, Sys->Version)) && !DmiIsGeneric(cp))
	Version = cp;
    if ((cp = DmiString(Hdr, Sys->Serial)) && !DmiIsGeneric(cp))
	Serial = cp;

    SImsg(SIM_DBG, "DMI SYSINFO: Mfg=<%s> Model=<%s> Version=<%s> Serial=<%s>",
	  PRTS(Mfg), PRTS(Model), PRTS(Version), PRTS(Serial));

    /*
     * If this is a specific query, then set the values now and return
     */
    if (Query && Query->Type == Hdr->Type) {
	Query->ValStr1 = Mfg;
	Query->ValStr2 = Model;
	Query->ValStr3 = Version;
	Query->ValStr4 = Serial;
	return DevInfo;
    }

    /*
     * Use the existing BIOS DevInfo if found, else create it
     */
    if (BiosDevInfo)
	DevInfo = BiosDevInfo;
    else
	DevInfo = NewBiosDevInfo();

    lp = &(DevInfo->DescList);

    if (Mfg)		AddDesc(lp, "System Mfg", Mfg, 0);
    if (Model)		AddDesc(lp, "System Model", Model, 0);
    if (Version)	AddDesc(lp, "System Version", Version, 0);
    if (Serial)		AddDesc(lp, "System Serial#", Serial, 0);
    if (Dmi->SmbiosVersion >= 2010) {
	if (Sys->UUID[0]) {
	    snprintf(Buff, sizeof(Buff), 
		     "%2X:%2X:%2X:%2X:%2X:%2X:%2X:%2X:%2X:%2X:%2X:%2X:%2X:%2X:%2X:%2X",
		     Sys->UUID[0], Sys->UUID[1], Sys->UUID[2], Sys->UUID[3], 
		     Sys->UUID[4], Sys->UUID[5], Sys->UUID[6], Sys->UUID[7], 
		     Sys->UUID[8], Sys->UUID[9], Sys->UUID[10], Sys->UUID[11], 
		     Sys->UUID[12], Sys->UUID[13], Sys->UUID[14], Sys->UUID[15]);
	    AddDesc(lp, "UUID", strdup(Buff), 0);
	}
    
	if (Sys->WakeUp && (cp = GetArrayEntry(WakeUpList, Sys->WakeUp)) && 
	    *cp)
	    AddDesc(lp, "Wake Up Setting", cp, 0);
    }

    return DevInfo;
}
