/*
 * Copyright (c) 1992-2002 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/4.2/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.2 $
 */

#ifndef __mcdmap_h__
#define __mcdmap_h__ 

#include <sys/types.h>

#define MCDMAP			"mcdmap"

/*
 * MCD Type
 */
struct _Mcd {
    int				Type;		/* File type */
    char		       *Src;		/* Path name of src file */
    char		       *Dest;		/* Destination path */
    char		       *Owner;		/* Owner name */
    char		       *Group;		/* Group owner */
    off_t			Size;		/* File size (bytes) */
    mode_t			Mode;		/* File mode */
    int				Flags;		/* Flags */
    struct _Mcd		       *Next;
};
typedef struct _Mcd Mcd_t;

/*
 * Values of Mcd_t.Type
 */
#define MCDT_FILE		1		/* Regular file */
#define MCDT_DIR		2		/* Directory */

/*
 * Values for Mcd_t.Flags
 */
#define MCDF_EDIT		0x01		/* Need to edit on install */

#endif	/* __mcdmap_h__ */
